summaryrefslogblamecommitdiffstats
path: root/scripts/system-restore
blob: dfc5c3a7d326773df1ad7dd302f50ac5999c9075 (plain) (tree)














































                                                                                              


                                                                                                                               
                                                                                                                                                                      

                                                      





                                                                                                              


                                                                                       







                  
#!/bin/bash

BACKUP="$1"
if [ -z "$BACKUP" ] || [ ! -f "$BACKUP" ]; then
	echo "Backup file not found: $BACKUP"
	exit 1
fi

if [ "$(whoami)" != "root" ]; then
	echo "Must be running as root!"
	exit 1
fi

DIR="/root/restore/$(date +%s)"

if [ -d "$DIR" ]; then
	echo "Restore already running!?"
	exit 1
fi

mkdir -p "$DIR"
if ! cd "$DIR"; then
	echo "Could not cd to $DIR"
	exit 1
fi

if ! tar --ignore-failed-read -x -f "$BACKUP"; then
	echo "Could not extract $BACKUP - make sure it's a valid .tar.gz / .tgz"
	exit 1
fi

if [ ! -f db.sql ]; then
	echo "Error: database dump not found in backup - are you sure this is a valid backup?"
	exit 1
fi

if [ ! -f files.tgz ]; then
	echo "Error: files.tgz not found in backup - are your sure this is a valid backup?"
	exit 1
fi

mysql --defaults-extra-file=/etc/mysql/debian.cnf --default-character-set=utf8 < db.sql
RET=$?
if [ $RET -ne 0 ]; then
	echo "Error: Restoring database contents failed with exit code $RET"
	exit 1
fi
# Since we came that far we'll delete some old configs (if existent)
rm -rf /opt/ldadp/{configs,pid,logs}/* /opt/openslx/configs/* /srv/openslx/www/boot/default/config.tgz 2> /dev/null
# Force triggering IP detection/setting, which should in turn regenerate ldadp configs and launch ldadp instances if applicable
echo "UPDATE openslx.property SET value = 'invalid' WHERE name = 'server-ip' LIMIT 1" | mysql --defaults-extra-file=/etc/mysql/debian.cnf --default-character-set=utf8
# Try to update the db (if required)
curl -s 'http://localhost/slx-admin/api.php?do=update'

tar --ignore-failed-read -x -f files.tgz -C /
RET=$?
if [ $RET -ne 0 ]; then
	echo "WARNING: Restoring filesystem contents failed with exit code $RET - backup might be incomplete!"
fi
# Make sure the directory tree is owned by taskmanager, as tar will create intermediate
# directories as owned by root if they do not exist.
chown -R taskmanager /srv/openslx/www/boot /opt/openslx/configs

rm -rf -- "$DIR"
rm -f -- "$BACKUP"

echo "Success."

exit 0